/*	CREAT.C	--	CONTAINS CREAT, OPEN, READ, WRITE, AND CLOSE	*/
/*				MS-DOS V2.0 version.	*/


/*	STANDARD FILE NUMBERS	*/

#define	STDIN	0
#define	STDOUT	1
#define	STDERR	2
#define STDPRN	4

/*	FILES contains status of all files	*/


#define CONTC	3
#define BS		8
#define LF		10
#define CR		13
#define CONTX	24
#define CONTZ	26
#define RUB		127

#define	NFILE	20
#define NBUFFER 8
#define BUF_MAX	64

#define BUF_UNUSED 0
#define BUF_IN	1
#define BUF_OUT	2

int  _files[NFILE]={0,1,2,3,4,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
				   -1,-1,-1,-1};
int _oldfile=99;		/* last file scanf'ed	*/
int _ungotten[NFILE]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
					  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
static char mode_3[NFILE];

static char buffer[NBUFFER][BUF_MAX+1],*buffer_at[NFILE],buffer_is[NFILE];

static _newfile(),_fixname(),alloc_buf(),dev_type();
long lseek();

/*	CREAT			filenum=creat(name)		*/

creat(name)
	char *name; {
	int  fnum,err;
	char newname[65];

	_fixname(newname,name);
	if ((fnum=_newfile()) == -1) return -1;
	err=_files[fnum]=_creat(newname);
	if (err == -1) return -1;
	alloc_buffer(fnum,err);
	mode_3[fnum]=0;
	return fnum;
	}



/*	OPEN			filenum=open(name,mode)		*/

open(name,mod)
	char *name,mod; {
	int  fnum,err;
	char newname[65],mode3;
	
	mode3=0;				/* no check for control z	*/
	if (mod > 2) {
		mod-=3;	/* mode 3 means test for control Z */
		mode3=1;
		}
	if (mod > 2) return -1;
	_fixname(newname,name);
	if ((fnum=_newfile()) == -1) return -1;
	err=_files[fnum]=_open(newname,mod);
	if (err == -1) return -1;
	alloc_buffer(fnum,err);
	mode_3[fnum]=mode3;
	return fnum;
	}





/*	READ			charactors read = read(filenum,buffer,nbytes);	*/

read(filenum,buffer,nbytes)
	int  filenum;
	unsigned nbytes;
	char *buffer; {
	int i,nin,fnum;
	char *buf;

	if (buffer_is[filenum]) {
		if (buffer_is[filenum] == BUF_OUT) fflush(filenum);
		if (nbytes < 16 || buffer_at[filenum][0] != BUF_MAX+1) {
			buf=buffer_at[filenum];
			for (i=0; i < nbytes; i++) {
				if (buf[0] == BUF_MAX+1) {
					if ((nin=read(filenum,&buf[1],BUF_MAX)) == 0)
						break;
					buf[0]=BUF_MAX-nin+1;
					if (nin < BUF_MAX) 
						_move(nin,&buf[1],
							&buf[BUF_MAX+1-nin]);
					}
				*buffer++=buf[buf[0]++];
				}
			return i;
			}
		}

	fnum=_files[filenum];
	nin=_read(fnum,buffer,nbytes);
	if (mode_3[filenum]) {		/* stop at control z	*/
		for (i=nin-1; i >=0; i--)
			if (buffer[i] == CONTZ) nin=i;
		}
	return nin;
	}



/*	WRITE			charactors written = write(filenum,buffer,nbytes);	*/

write(filenum,buffer,nbytes)
	int  filenum;
	unsigned nbytes;
	char *buffer; {
	int  i;
	char *buf;

	buf=buffer_at[filenum];
	if (buffer_is[filenum] == BUF_IN) {
		if (buf[0] != BUF_MAX+1)
			lseek(filenum,0L,1);
		buffer_is[filenum]=BUF_OUT;
		buf[0]=1;
		}

	if (buffer_is[filenum]) {
		if (nbytes < 16) {
			for (i=0; i < nbytes; i++) {
				buf[buf[0]++]=*buffer++;
				if (buf[0] == BUF_MAX+1) {
					if (fflush(filenum) == -1)
						return -1;
					buffer_is[filenum]=BUF_OUT;
					buf[0]=1;
					}
				}
			return nbytes;
			}
		if (buf[0] !=1) {
			fflush(filenum);
			buffer_is[filenum]=BUF_OUT;
			buf[0]=1;
			}
		}

	filenum=_files[filenum];
	return _write(filenum,buffer,nbytes);
	}



/*	CLOSE			error = close(file number);	*/

close(filenum)
	int  filenum; {
	int fnum;

	_oldfile=99;
	fflush(filenum);
	if (buffer_is[filenum]) *buffer_at[filenum]=0;
	buffer_is[filenum]=BUF_UNUSED;
	if (filenum > STDPRN) {
		fnum=_files[filenum];
		_files[filenum]=-1;
		return _close(fnum);
		}
	return 0;
	}




/*	GETC, GETW, PUTC, PUTW		*/

getc(filenum)
	int  filenum; {
	int  value,filen;

	value=0;
	filen=_files[filenum];
	if (_ungotten[filen] != -1) {
		value=_ungotten[filen];
		_ungotten[filen]=-1;
		return value;
		}
	if (read(filenum,&value,1) == 0) value=26;
	if (value == 26) value=-1;
	return value;
	}


getw(filenum)
	int  filenum; {
	int  value;

	if (read(filenum,&value,2) != 2) value=-1;
	return value;
	}


putc(ch,filenum)
	int  filenum;
	char ch; {

	return write(filenum,&ch,1);
	}

putw(wrd,filenum)
	int  filenum;
	int  wrd; {

	return write(filenum,&wrd,2);
	}



ungetc(c,filenum)
	int c;
	int filenum; {

	_ungotten[filenum]=c;
	return c;
	}



/*	FGETS  --	INPUT A LINE FROM A FILE	*/

fgets(str,n,filenum)
	char *str;
	int  n,filenum; {
	int  ch,oldstr;

	oldstr=str;
	while (--n && (ch=getc(filenum)) >= 0 && ch != CONTZ) {
		if (ch != CR) *str++=ch;
		if (ch == '\n') break;
		}
	*str=0;
	if (oldstr == str) oldstr=0;
	return oldstr;
	}



/*	FPUTS  --	WRITE A STRING TO A FILE	*/

fputs(str,filenum)
	char *str;
	int  filenum; {
	int  err;
	char ch;

	while (ch=*str++) {
		if (ch == '\n') putc('\r',filenum);
		err=putc(ch,filenum);
		}
	return err;
	}




/*	GETS			string address=gets(string address);	*/
static int  getat;

gets(str)
	char *str; {

	_gets(getat=str,512);
	return getat;
	}



/*	_gets	gets with a maximum length	*/

_gets(str,max)
	char str[1];
	int  max; {
	int  ch,filenum;
	char *oldstr;

	oldstr=str;
	while (--max && (ch=getc(0)) >= 0 && ch != CONTZ) {
		if (ch == '\n') break;
		if (ch != CR) *str++=ch;
		}
	*str=0;
	str-=oldstr;
	if (str == 0) getat=0;
	return str;
	}



/*	UNLINK			error code=unlink(file)		*/

unlink(name)
	char *name; {

	return _unlink(name);
	}


/*	RENAME			error code = rename(old name, new name);	*/

rename(old,new)
	char *old,*new; {

	return _rename(old,new);
	}



/*	LSEEK			error code = lseek(file number, fileoff, code);
					0=seek from start.
					1=seek from current.
					2=seek from end.			*/

long lseek(filenum,fileoff,code)
	int  filenum;
	long fileoff;
	char code; {

	_oldfile=99;
	if (buffer_is[filenum] == BUF_OUT) fflush(filenum);
	else {
			/*	adjust if buffered and doing relative seek	*/
		if (buffer_is[filenum] == BUF_IN && code == 1) {
			fileoff+=((int)buffer_at[filenum][0])-BUF_MAX-1;
			}
		buffer_at[filenum][0]=BUF_MAX+1;
		}
	filenum=_files[filenum];
	return _lseek(filenum,fileoff,code);
	}



/*		_newfile allocates a unused file number. */

_newfile() {
	int  i;

	for (i=STDPRN+1; i < NFILE; i++) {
		if (_files[i] == -1) return i;
		}
	return -1;
	}



/*		_fixname removes the colon from a device name.	*/

_fixname(newname,name)
	char *newname,*name; {

	do {
		*newname++=*name;
		}
	while (*name++);
	if (*(newname-2) == ':') *(newname-2)=0; /* chop off the trailing colon */
	}


/*	fflush  --	flush a buffer for a file.	*/

fflush(filenum)
	int  filenum; {
	int  err,nout;
	char *buf;

	err=0;
	if (buffer_is[filenum]) {
		buf=buffer_at[filenum];
		nout=buf[0]-1;
		if (buffer_is[filenum] == BUF_OUT) {
			buffer_is[filenum]=BUF_IN;
			buf[0]=BUF_MAX+1;
			if (nout) {
				filenum=_files[filenum];
				err=_write(filenum,&buf[1],nout);
				}
			}
		}
	return err;
	}

		

/*	alloc_buffer  --	allocate a buffer if a disk file.	*/

alloc_buffer(filenum,msnum)
	int  filenum,msnum; {
	int  i;
	
	buffer_is[filenum]=BUF_UNUSED;		/* no buffer for this file */

	if ((dev_type(msnum) & 0x80) == 0) {	/* have a disk file */

		/*	see if have a free buffer	*/
		for (i=0; i < NBUFFER; i++) {
			if (buffer[i][0] == 0) {
				buffer[i][0]=BUF_MAX+1;
				buffer_is[filenum]=BUF_IN;
				buffer_at[filenum]=&buffer[i][0];
				return;
				}
			}
		}
	}




/*	dev_type  --  return the device type for a file.	*/

dev_type(filenum)
	int  filenum; {

#asm
	mov		ah,44h				;code for ioctl
	mov		al,0				;code for return info
	mov		bx,[bp+4]			;file number
	int		21h					;call ms-dos
	mov		ax,dx				;device info
#
	}
